<?php
$berogui_path = '/usr/local/www/berogui';
require("$berogui_path/includes/Helper/Helper.php");

##### INTERN FUNCTIONS #####
function doCacheUpdate($bc, &$html = null, &$msg = null) {
	$output = null;
	$retval = Helper::system(1, "/bin/bash /etc/cron.daily/sbcvm-check-update >/dev/null", $output, ['timeout' => 300]);
	$retval &= Helper::system(1, "/usr/bin/dpkg --configure -a >/dev/null", $output, ['timeout' => 300]);
	if ($retval != false) {
		global $berogui_path;
		require_once("$berogui_path/modules/UpdateTool/UpdateTool.php");
		include_once("$berogui_path/includes/lang.php");
		$upd = new UpdateTool();
		$html = $upd->loadFormByTab(1);
		$msg = $bc->get('root', 'sbcvm-has-update') == 1 && $bc->get('root', 'sbcvm-update-shownotif') == 1 ? NEW_PACKAGE_AVAILABLE_MESSAGE_DIS : '';
		return(true);
	}
	return(false);
}
function doUpdate($reboot_required) {
	/* set a low timeout value to switch to the check_update request */
	$retval = Helper::system(1, "/bin/bash /usr/local/beroNet/bin/sbcvm-update $reboot_required >/dev/null", $output, ['timeout' => 600]);
	return($retval != false);
}

##### FORCE UPDATE AFTER AUTO FAILED OR TO FIX A MAJOR ISSUE ######
if (isset($_POST['force-update']) && $_POST['force-update']) {
	include_once("$berogui_path/includes/lang.php");
	if (Helper::getActivateOption() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTIVATE_NOTIF]));
	}
	else if (Helper::getTotalCalls() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTCALLS_NOTIF]));
	}
}
##### RELOAD APT CACHE ####
else if (isset($_POST['reload_aptcache']) && $_POST['reload_aptcache']) {
	require_once('/usr/fallback/beroConf.php');
	$bc = new beroConf('root');

	$msg = '';
	$html = '';
	header('Content-type: application/json');
	die(Helper::jsonEncode(['status' => doCacheUpdate($bc, $html, $msg), 'html' => $html, 'msg' => $msg]));
}

##### MANUAL/FORCE UPDATE #####
/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST);

/* [EXEC AJAX] */
require_once('/usr/fallback/beroConf.php');
$bc = new beroConf('root');

### file overwritte during update. should lead to a fail
include_once("$berogui_path/includes/lang.php");

header('Content-type: application/json');
if (doUpdate($bc->get('root', 'sbcvm-update-reboot') == 1 ? 1 : 0)) {
	die(Helper::jsonEncode(['fw' => $bc->get('root', 'sbcvm-package-current'), 'success' => UPDATE_TOOL_SBCVM_SUCCESSFUL]));
}
http_response_code(500);
die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED]));
exit(0);
?>
